// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	apiauthorizationv1 "github.com/openshift/api/authorization/v1"
	internal "github.com/openshift/client-go/authorization/applyconfigurations/internal"
	runtime "k8s.io/apimachinery/pkg/runtime"
	managedfields "k8s.io/apimachinery/pkg/util/managedfields"
	v1 "k8s.io/client-go/applyconfigurations/meta/v1"
)

// ResourceAccessReviewApplyConfiguration represents an declarative configuration of the ResourceAccessReview type for use
// with apply.
type ResourceAccessReviewApplyConfiguration struct {
	v1.TypeMetaApplyConfiguration `json:",inline"`
	ActionApplyConfiguration      `json:",inline"`
}

// ResourceAccessReview constructs an declarative configuration of the ResourceAccessReview type for use with
// apply.
func ResourceAccessReview(name string) *ResourceAccessReviewApplyConfiguration {
	b := &ResourceAccessReviewApplyConfiguration{}
	b.WithKind("ResourceAccessReview")
	b.WithAPIVersion("authorization.openshift.io/v1")
	return b
}

// ExtractResourceAccessReview extracts the applied configuration owned by fieldManager from
// resourceAccessReview. If no managedFields are found in resourceAccessReview for fieldManager, a
// ResourceAccessReviewApplyConfiguration is returned with only the Name, Namespace (if applicable),
// APIVersion and Kind populated. It is possible that no managed fields were found for because other
// field managers have taken ownership of all the fields previously owned by fieldManager, or because
// the fieldManager never owned fields any fields.
// resourceAccessReview must be a unmodified ResourceAccessReview API object that was retrieved from the Kubernetes API.
// ExtractResourceAccessReview provides a way to perform a extract/modify-in-place/apply workflow.
// Note that an extracted apply configuration will contain fewer fields than what the fieldManager previously
// applied if another fieldManager has updated or force applied any of the previously applied fields.
// Experimental!
func ExtractResourceAccessReview(resourceAccessReview *apiauthorizationv1.ResourceAccessReview, fieldManager string) (*ResourceAccessReviewApplyConfiguration, error) {
	return extractResourceAccessReview(resourceAccessReview, fieldManager, "")
}

// ExtractResourceAccessReviewStatus is the same as ExtractResourceAccessReview except
// that it extracts the status subresource applied configuration.
// Experimental!
func ExtractResourceAccessReviewStatus(resourceAccessReview *apiauthorizationv1.ResourceAccessReview, fieldManager string) (*ResourceAccessReviewApplyConfiguration, error) {
	return extractResourceAccessReview(resourceAccessReview, fieldManager, "status")
}

func extractResourceAccessReview(resourceAccessReview *apiauthorizationv1.ResourceAccessReview, fieldManager string, subresource string) (*ResourceAccessReviewApplyConfiguration, error) {
	b := &ResourceAccessReviewApplyConfiguration{}
	err := managedfields.ExtractInto(resourceAccessReview, internal.Parser().Type("com.github.openshift.api.authorization.v1.ResourceAccessReview"), fieldManager, b, subresource)
	if err != nil {
		return nil, err
	}

	b.WithKind("ResourceAccessReview")
	b.WithAPIVersion("authorization.openshift.io/v1")
	return b, nil
}

// WithKind sets the Kind field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Kind field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithKind(value string) *ResourceAccessReviewApplyConfiguration {
	b.Kind = &value
	return b
}

// WithAPIVersion sets the APIVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the APIVersion field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithAPIVersion(value string) *ResourceAccessReviewApplyConfiguration {
	b.APIVersion = &value
	return b
}

// WithNamespace sets the Namespace field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Namespace field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithNamespace(value string) *ResourceAccessReviewApplyConfiguration {
	b.Namespace = &value
	return b
}

// WithVerb sets the Verb field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Verb field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithVerb(value string) *ResourceAccessReviewApplyConfiguration {
	b.Verb = &value
	return b
}

// WithGroup sets the Group field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Group field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithGroup(value string) *ResourceAccessReviewApplyConfiguration {
	b.Group = &value
	return b
}

// WithVersion sets the Version field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Version field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithVersion(value string) *ResourceAccessReviewApplyConfiguration {
	b.Version = &value
	return b
}

// WithResource sets the Resource field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Resource field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithResource(value string) *ResourceAccessReviewApplyConfiguration {
	b.Resource = &value
	return b
}

// WithResourceName sets the ResourceName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceName field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithResourceName(value string) *ResourceAccessReviewApplyConfiguration {
	b.ResourceName = &value
	return b
}

// WithPath sets the Path field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Path field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithPath(value string) *ResourceAccessReviewApplyConfiguration {
	b.Path = &value
	return b
}

// WithIsNonResourceURL sets the IsNonResourceURL field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the IsNonResourceURL field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithIsNonResourceURL(value bool) *ResourceAccessReviewApplyConfiguration {
	b.IsNonResourceURL = &value
	return b
}

// WithContent sets the Content field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Content field is set to the value of the last call.
func (b *ResourceAccessReviewApplyConfiguration) WithContent(value runtime.RawExtension) *ResourceAccessReviewApplyConfiguration {
	b.Content = &value
	return b
}
